#!/usr/bin/microperl -w


require "status/devices.pm";
require "status/environment.pm";

# -----------------
# CGI-Env
my %ENV = &get_env();
my %form_value = &parse_from_data(%ENV);
# -----------------

my @devices  = getNetworkDev();
&try_function_status();

&print_site_header();
&print_menu_left();
&print_menu_main($form_value{'menu'});


print "</body>\n</html>\n";




#-------------------------------------
#
# Sub
#
#-------------------------------------



#-------------------------------------
sub try_function_status {
  # allgeminer gestalten
   if(defined($form_value{'OpenVPN'})) {
     &function_status('OpenVPN', $form_value{'OpenVPN'});
   }
   elsif(defined($form_value{'Reboot'})) {
     &function_status('Reboot', $form_value{'Reboot'});
   }
   elsif(defined($form_value{'AP'})) {
     &function_status('AP', $form_value{'AP'});
   }

}

#-------------------------------------
sub function_status {
  my ($function, $status) = @_;

  if ($function eq 'OpenVPN') {
    # aus sicherheitsgruenden pruefen
    if(($status eq 'restart')
       || ($status eq 'stop')
       || ($status eq 'start')) {
      system("/etc/init.d/S55openvpn $status");
    }
  }
  elsif($function eq 'Reboot') {
    if(($status eq 'reboot') || ($status eq 'halt')) {
      system("$status");
    }
  }
  elsif($function eq 'AP') {
    if($status =~ m/^..:..:..:..:..:..$/) {
      system("/usr/sbin/iwconfig eth1 ap $status");
    }
  }
}


#-------------------------------------
sub print_function_status {
   my ($function) = @_;

   if ($function eq 'OpenVPN') {
     print "<tr><td width=\"200\">OpenVPN</td>\n";
     print "<td><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"start\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"stop\">\n";
     print "<input type=\"submit\" name=\"OpenVPN\" value=\"restart\">\n";
     print "</form></td></tr>\n";
   }
   elsif ($function eq 'Reboot') {
     print "<tr><td>System Reboot</td>\n";
     print "<td><form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
     print "<input type=\"submit\" name=\"Reboot\" value=\"halt\">\n";
     print "<input type=\"submit\" name=\"Reboot\" value=\"reboot\">\n";
     print "</form></td></tr>\n";
   }
}


#-------------------------------------
sub uptime_status {
  my $pid;
  my $out;

  $pid = open(UPTIME, "/usr/bin/uptime |") or die;
  $out = <UPTIME>;
  close (UPTIME);

 return($out);
}

#-------------------------------------
sub print_mount_status {
  my $pid;
  my @out;
  my $line;

  $pid = open(MOUNT, "/bin/mount |") or die;
  @out = <MOUNT>;
  close (MOUNT);

  foreach $line (@out) {
    print $line."<br>\n";
  }

  # df
  $pid = open(MOUNT, "df -h |") or die;
  @out = <MOUNT>;
  close (MOUNT);

  print "<p><pre>";
  foreach $line (@out) {
    print $line;
  }
  print "</pre></p>\n";

  return();
}


#-------------------------------------
sub print_device_status {
 my (@devices) = @_;
 my $dev;
 my $pid;
 my $zeile;
 my @out;

 my $actual_ap = '';
 
 if(defined($form_value{'if'})) {
   @devices = ("$form_value{'if'}");
 }
 
 foreach $dev (@devices) {
   print "Device: $dev<br><pre>";
 
   $pid = open(IFCONFIG, "/sbin/ifconfig $dev |"); # or return "no ifconfig found";
   @out = <IFCONFIG>;
   close (IFCONFIG);
   
   foreach $zeile (@out) {  
     print "$zeile";
   }
   print "</pre>\n";
 }

## AP-List
# $ap_pid = open(APLIST, "<ap_list") or die "no ap_list";
# @ap_list = <APLIST>;
# close(APLIST);
 

# WLAN - iwconfig
  $pid = open(IWCONFIG, "/usr/sbin/iwconfig eth1 |"); # or die "no iwconfig found";
  @out = <IWCONFIG>;
  close (IWCONFIG);


 print "<div>\n";
  print "<hr><pre>\n";
  foreach $zeile (@out) {
     print "$zeile";
        if ($zeile =~ m/..:..:..:..:..:../) {
	$actual_ap = &in_aplist($zeile);
	if($actual_ap ne '') {
	   print "---------   $actual_ap ---------\n";
	   
#          if ($zeile =~ m/00:02:2D:4F:6F:3B/i) {
#                print "\t<a href=\"http://www.goemobile.de/apadmin/viewap.php?apId=28\">"
#                        ."<b>Accesspoint: Rathaus Nord/Ost Interface 2</b></a>\n";
#          }
#          elsif ($zeile =~ m/00:0e:d7:ca:58:20/i) {
#                print "\t<b>Accesspoint Rathaus Nord Interface 2 (neu! 54 MBit)</b>\n";
#          }
#          elsif ($zeile =~ m/00:02:2d:4f:6f:02/i) {
#                print "\t<b>Accesspoint Rathaus Nord Interface 3</b>\n";
#          }
#          elsif ($zeile =~ m/00:02:2d:03:66:6b/i) {
#                print "\t<a href=\"http://www.goemobile.de/apadmin/viewap.php?apId=27\">"
#                     ."<b>Accesspoint Rathaus S&uuml;d West Interface 2</b></a>\n";
#          }
#          elsif ($zeile =~ m/00:02:2d:4f:6f:20/i) {
#                print "\t<a href=\"http://www.goemobile.de/apadmin/viewap.php?apId=27\">"
#                     ."<b>Accesspoint Rathaus S&uuml;d West Interface 3</b></a>\n";
#		print "<b>Accesspoint Rathaus S&uuml;d West Interface 3</b>\n";
#          }
#          else {
#             if ($zeile =~ m/00:00:00:00:00:00/i) {
#                print "\t<font color=\"red\"><b>Kein Accesspoint!</b></font>\n";
             }
             else {
                print "\t<font color=\"red\">unbekannter Accesspoint!</font>\n";
             }
#          }
        }
  }

  print "</pre>\n";
  print "</div>\n";

   $pid = open(IFCONFIG, "cat /proc/net/dev |");
   @out = <IFCONFIG>;
   close (IFCONFIG);
   print "<hr><pre>@out</pre>\n";

}




sub print_site_header { 
  print "Content-Type: text/html\n\n";
  print '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
  
  print "\n<html>\n"
    ."<head>\n"
      ."<title>Status - ASUS WL-500g deluxe</title>\n"
	."<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />\n"
	  ."<meta name=\"copyright\" content=\"&copy; St. Teusch & St. Wagner\" />\n"
	    ."</head>\n";
  
  print "<body bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#FFFFFF\" "
    ."vlink=\"#FFFFFF\" alink=\"#FFFFFF\">\n";
  print "<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n ";
  print "<tr><td colspan=\"2\" height=\"50\" bgcolor=\"#5500AA\" align=\"right\">"
    ."<font color=\"white\">OpenWRT on ASUS WL-500g deluxe (alpha)</font> "
      ."</td></tr>\n";

}

sub print_menu_left {
  print "<tr><td align=\"left\" valign=\"top\" width=\"120\" height=\"700\" bgcolor=\"#5500AA\">\n";

  print "<table border=\"0\" vspace=\"8\" hspace=\"5\">";
  
    print "<tr><td>";
    print "<a href=\"".$ENV{SCRIPT_NAME}."?menu=interfaces\">Interfaces</a>";

    print "<ul>\n";
  foreach my $dev (@devices) {
    print "<li><a href=\"".$ENV{SCRIPT_NAME}."?menu=interfaces&if=".$dev."\">".$dev."</a></li>";
  }
  print "</ul>";
  print "</td></tr>\n";

  print "<tr><td><a href=\"$ENV{SCRIPT_NAME}?menu=sel_ap\">Select AP</a></td></tr>\n";

  print "<tr><td><a href=\"$ENV{SCRIPT_NAME}?menu=devices\">Devices</a></td></tr>\n";
  print "<tr><td><a href=\"$ENV{SCRIPT_NAME}?menu=services\">Services</a></td></tr>\n";
  print "<tr><td><a href=\"$ENV{SCRIPT_NAME}?menu=uptime\">Uptime</a></td></tr>\n";
  print "</table>\n";

  print "</td>\n";
}


sub print_menu_main {
  my ($menu) = @_;
  
  $menu = '' unless(defined($menu));

  print "<td align=\"left\" valign=\"top\" width=\"*\">\n";
    print "<table border=\"0\" vspace=\"5\" hspace=\"5\">\n";

  if($menu eq 'interfaces') {
    print "<center><strong>Interfaces</strong></center><hr>\n";
    &print_device_status(@devices);
  }
  elsif($menu eq 'devices') {
    print "<center><strong>Devices</strong></center><hr>\n";
    &print_mount_status();
  }
  elsif($menu eq 'sel_ap') {
    print "<center><strong>Select Access Point</strong></center><hr>\n";
    &print_select_accesspoint();
  }
  elsif($menu eq 'uptime') {
    print "<center><strong>Uptime</strong></center><hr>\n";

    print "<p>";
    open(UPTIME, "cat /proc/version |"); # or die;
    print <UPTIME>;
    close (UPTIME);
    print "</p>";

    print &uptime_status();
  }
  elsif($menu eq 'services') {
    print "<center><strong>Services</strong></center><hr>\n";
    &print_function_status('OpenVPN');
    &print_function_status('Reboot');
  }
  else {
    print "Welcome";
  }

  print "</table>\n";
  print "</td></tr>\n";
  print "<tr><td colspan=\"2\" align=\"right\">"
    ."<hr><font size=\"1\">&copy; St. Teusch &amp; St. Wagner</font>\n"
      ."</td></tr>\n";
  
  print "</table>\n";
  
}



#
#
#
sub print_select_accesspoint {
  open(AP_LIST, "<ap_list");
  my @ap_list = <AP_LIST>;
  close(AP_LIST);

  my $i;
  my $ap_mac;
  my $ap_name;
  my $ap_url;
  my %ap_now = &getAP_ID();



  print "<form action=\"$ENV{'SCRIPT_NAME'}\" method=\"POST\">\n";
  print "<input type=\"hidden\" name=\"menu\" value=\"sel_ap\">\n";

  print "<table border=\"0\">\n";

  print "<tr><td colspan=\"4\">Aktueller Access Point:</td></tr>\n";
  print "<tr><td></td><td>";
  if(defined($ap_now{'mac'})) {
    print $ap_now{'mac'};
  }
  print "</td><td>";
  if(defined($ap_now{'name'})) {
    print "<b>".$ap_now{'name'}."</b>";
  }
  print "</td><td>";
  if(defined($ap_now{'url'})) {
    print $ap_now{'url'};
  }
  print "</td></tr>\n";
  print "<tr><td colspan=\"4\"><hr></td></tr>\n";

  for($i=0; $i < @ap_list; $i++) {
    ($ap_mac, $ap_name, $ap_url) = split(/;;/, $ap_list[$i]);
    print "<tr>";
     print "<td><input type=\"submit\" name=\"AP\" value=\"$ap_mac\"></td>\n";
    print "<td>".$ap_mac."</td><td><b>".$ap_name."</b></td><td>".$ap_url."</td></tr>\n";
  }
  print "</table>\n";
  print "</form>\n";



}

sub in_aplist {
 my ($ap) = @_;

 # AP-List
 my $ap_pid = open(APLIST, "<ap_list") or die "no ap_list";
 my @ap_list = <APLIST>;
 close(APLIST);
    
 for(my $i=0; $i < @ap_list; $i++) {
    if ($ap_list[$i] =~ m/$ap/i) {
      return "$ap_list[$i]";
    }
 }

 return '';
}
